質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.36%

  • Ruby on Rails

    8118questions

    Ruby on Railsは、オープンソースのWebアプリケーションフレームワークです。「同じことを繰り返さない」というRailsの基本理念のもと、他のフレームワークより少ないコードで簡単に開発できるよう設計されています。

railsでkaminariを使ってページネーションを作りたいのにページでコンテンツが変わらない

解決済

回答 1

投稿

  • 評価
  • クリップ 1
  • VIEW 569

you88

score 90

今railsでkaminariを用いてページネーションを作ろうとしています。
下記の手順でページネーションは表示されているのですがページを変えてもコンテンツが変わらないのと表示数の通りに数がなりません。

http://qiita.com/you88/items/df68aaee3010e282d1ae

コードは下記になります。

@page = Post.page(params[:page]).per(3)

表示件数を変えるためにはどうしたらいいでしょうか。。。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

@page = Post.all.page(params[:page])

コントローラに書くのは、あまり美しくないですし後から変更したい時に不便になります。
モデルにかくと設定できます。

# app/models/post.rb

class Post < ActiveRecord::Base
  paginates_per 5  # 1ページあたり5項目表示
end

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/09/14 07:45

    なんかまだ制限できないです。。。ページを変えてもコンテンツが変わらないのでそもそもkaminariがうまく入っていないのかもしれないです。

    キャンセル

  • 2017/09/14 08:00

    rails5だとgem 'kaminari', '~> 0.17.0'でないと動かないと言う記事を見つけ、バージョンを変更したのですが動かない。。。

    キャンセル

  • 2017/09/14 13:04

    kaminariのバージョンはあまり関係ないと思います。
    rails g kaminari:config
    でconfigファイルを生成して、設定するのがいいかもしれないです。
    http://ruby-rails.hatenadiary.com/entry/20141113/1415874683

    キャンセル

  • 2017/09/16 12:31

    うう、この記事の通りにやっているんですがrailsのバージョンなのか。。。

    キャンセル

  • 2017/09/16 17:26

    kaminariを一度入れ直して見ましょう。
    gemfileからgem kaminariを削除します。gem uninstall 'kaminari'をした後、Gemfile.lockも削除します。
    bundle installでrailsから完全にkaminariを削除できます。

    そしたら再び入れ直してみてください。

    キャンセル

  • 2017/09/16 20:11

    入れ直したら動きました!ありがとうございます!

    キャンセル

  • 2017/09/17 01:19

    よかったです!

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.36%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • Ruby on Rails

    8118questions

    Ruby on Railsは、オープンソースのWebアプリケーションフレームワークです。「同じことを繰り返さない」というRailsの基本理念のもと、他のフレームワークより少ないコードで簡単に開発できるよう設計されています。